<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTicketSchemeEnrollmentData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTicketSchemeEnrollmentData
 * @subpackage Arrays
 */
class ArrayOfTicketSchemeEnrollmentData extends AbstractStructArrayBase
{
    /**
     * The TicketSchemeEnrollmentData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\TicketSchemeEnrollmentData[]
     */
    public $TicketSchemeEnrollmentData;
    /**
     * Constructor method for ArrayOfTicketSchemeEnrollmentData
     * @uses ArrayOfTicketSchemeEnrollmentData::setTicketSchemeEnrollmentData()
     * @param \patest\StructType\TicketSchemeEnrollmentData[] $ticketSchemeEnrollmentData
     */
    public function __construct(array $ticketSchemeEnrollmentData = array())
    {
        $this
            ->setTicketSchemeEnrollmentData($ticketSchemeEnrollmentData);
    }
    /**
     * Get TicketSchemeEnrollmentData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\TicketSchemeEnrollmentData[]|null
     */
    public function getTicketSchemeEnrollmentData()
    {
        return isset($this->TicketSchemeEnrollmentData) ? $this->TicketSchemeEnrollmentData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTicketSchemeEnrollmentData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTicketSchemeEnrollmentData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTicketSchemeEnrollmentDataForArrayConstraintsFromSetTicketSchemeEnrollmentData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTicketSchemeEnrollmentDataTicketSchemeEnrollmentDataItem) {
            // validation for constraint: itemType
            if (!$arrayOfTicketSchemeEnrollmentDataTicketSchemeEnrollmentDataItem instanceof \patest\StructType\TicketSchemeEnrollmentData) {
                $invalidValues[] = is_object($arrayOfTicketSchemeEnrollmentDataTicketSchemeEnrollmentDataItem) ? get_class($arrayOfTicketSchemeEnrollmentDataTicketSchemeEnrollmentDataItem) : sprintf('%s(%s)', gettype($arrayOfTicketSchemeEnrollmentDataTicketSchemeEnrollmentDataItem), var_export($arrayOfTicketSchemeEnrollmentDataTicketSchemeEnrollmentDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TicketSchemeEnrollmentData property can only contain items of type \patest\StructType\TicketSchemeEnrollmentData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TicketSchemeEnrollmentData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\TicketSchemeEnrollmentData[] $ticketSchemeEnrollmentData
     * @return \patest\ArrayType\ArrayOfTicketSchemeEnrollmentData
     */
    public function setTicketSchemeEnrollmentData(array $ticketSchemeEnrollmentData = array())
    {
        // validation for constraint: array
        if ('' !== ($ticketSchemeEnrollmentDataArrayErrorMessage = self::validateTicketSchemeEnrollmentDataForArrayConstraintsFromSetTicketSchemeEnrollmentData($ticketSchemeEnrollmentData))) {
            throw new \InvalidArgumentException($ticketSchemeEnrollmentDataArrayErrorMessage, __LINE__);
        }
        if (is_null($ticketSchemeEnrollmentData) || (is_array($ticketSchemeEnrollmentData) && empty($ticketSchemeEnrollmentData))) {
            unset($this->TicketSchemeEnrollmentData);
        } else {
            $this->TicketSchemeEnrollmentData = $ticketSchemeEnrollmentData;
        }
        return $this;
    }
    /**
     * Add item to TicketSchemeEnrollmentData value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\TicketSchemeEnrollmentData $item
     * @return \patest\ArrayType\ArrayOfTicketSchemeEnrollmentData
     */
    public function addToTicketSchemeEnrollmentData(\patest\StructType\TicketSchemeEnrollmentData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\TicketSchemeEnrollmentData) {
            throw new \InvalidArgumentException(sprintf('The TicketSchemeEnrollmentData property can only contain items of type \patest\StructType\TicketSchemeEnrollmentData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TicketSchemeEnrollmentData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\TicketSchemeEnrollmentData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\TicketSchemeEnrollmentData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\TicketSchemeEnrollmentData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\TicketSchemeEnrollmentData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\TicketSchemeEnrollmentData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TicketSchemeEnrollmentData
     */
    public function getAttributeName()
    {
        return 'TicketSchemeEnrollmentData';
    }
}
